﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using ThinkGeo.MapSuite;
using ThinkGeo.MapSuite.Shapes;
using ThinkGeo.MapSuite.Wpf;

namespace TestMap
{
    /// <summary>
    /// Lógica de interacción para MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }





        private void BingButton_Click(object sender, RoutedEventArgs e)
        {
            wpfMap.Overlays["Google"].IsVisible = false;
            wpfMap.Overlays["Bing"].IsVisible = true;
            wpfMap.Overlays["OSM"].IsVisible = false;

            wpfMap.Refresh();
        }
        private void GoogleButton_Click(object sender, RoutedEventArgs e)
        {
            wpfMap.Overlays["Google"].IsVisible = true;
            wpfMap.Overlays["Bing"].IsVisible = false;
            wpfMap.Overlays["OSM"].IsVisible = false;

            wpfMap.Refresh();
        }

        private void OSMButton_Click(object sender, RoutedEventArgs e)
        {
            wpfMap.Overlays["Google"].IsVisible = false;
            wpfMap.Overlays["Bing"].IsVisible = false;
            wpfMap.Overlays["OSM"].IsVisible = true;

            wpfMap.Refresh();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            wpfMap.MapUnit = GeographyUnit.DecimalDegree;
            wpfMap.MapTools.MouseCoordinate.IsEnabled = true;
            wpfMap.MapTools.MouseCoordinate.MouseCoordinateType = MouseCoordinateType.LatitudeLongitude;
            wpfMap.MapTools.PanZoomBar.Visibility = Visibility.Collapsed;
            wpfMap.MapTools.Logo.Visibility = Visibility.Collapsed;

            wpfMap.CurrentExtent = new RectangleShape(maxX: -0.440168380737305, maxY: 39.5093501091003, minX: -0.29597282409668, minY: 39.4315016746521);

            GoogleMapsOverlay googleOverlay = new GoogleMapsOverlay();
            googleOverlay.DrawingExceptionMode = ThinkGeo.MapSuite.Drawing.DrawingExceptionMode.ThrowException;
            Proj4Projection proj4Google = new Proj4Projection();
            proj4Google.InternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
            proj4Google.ExternalProjectionParametersString = Proj4Projection.GetDecimalDegreesParametersString();
            proj4Google.Open();
            googleOverlay.IsVisible = false;
            googleOverlay.ProjectionFromSphericalMercator = proj4Google;

            BingMapsOverlay bingOverlay = new BingMapsOverlay();
            bingOverlay.ApplicationId = "ApplicationId";
            Proj4Projection proj4Bing = new Proj4Projection();
            proj4Bing.InternalProjectionParametersString = Proj4Projection.GetBingMapParametersString();
            proj4Bing.ExternalProjectionParametersString = Proj4Projection.GetDecimalDegreesParametersString();
            proj4Bing.Open();
            bingOverlay.IsVisible = true;
            bingOverlay.ProjectionFromSphericalMercator = proj4Bing;

            OpenStreetMapOverlay OSMOverlay = new OpenStreetMapOverlay();
            Proj4Projection proj4OSM = new Proj4Projection();
            proj4OSM.InternalProjectionParametersString = Proj4Projection.GetSphericalMercatorParametersString();
            proj4OSM.ExternalProjectionParametersString = Proj4Projection.GetDecimalDegreesParametersString();
            proj4OSM.Open();
            OSMOverlay.IsVisible = false;
            OSMOverlay.ProjectionFromSphericalMercator = proj4OSM;

            wpfMap.Overlays.Add("Bing", bingOverlay);
            wpfMap.Overlays.Add("Google", googleOverlay);
            wpfMap.Overlays.Add("OSM", OSMOverlay);

            wpfMap.Refresh();

        }
    }
}
